/*
 * Copyright (C) 2022  Aleksei Bavshin
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, version 3.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef QMLGREET_QMLGREETER_HPP_
#define QMLGREET_QMLGREETER_HPP_

#include <QtCore>

QT_BEGIN_NAMESPACE
class QQmlEngine;
class QQuickView;
class QScreen;
QT_END_NAMESPACE

namespace QmlGreet {

class QGreeterContext;

class QmlGreeterTheme {
  public:
    QmlGreeterTheme() = default;
    QmlGreeterTheme(QString dirName);

    QString background = QString();
    QUrl entryPoint = QUrl{"qrc:/Main.qml"};
    QUrl importPath = QUrl{"qrc:/"};
};

class QmlGreeter : public QObject {
    Q_OBJECT;

  public:
    QmlGreeter(QObject *parent = nullptr);

  public slots:
    void start();

  private slots:
    void createViewForScreen(QScreen *screen);

  private:
    QmlGreeterTheme m_theme;
    QQmlEngine *m_engine;
    QGreeterContext *m_context;
    QList<QQuickView *> m_views;
};
} // namespace QmlGreet

#endif /* QMLGREET_QMLGREETER_HPP_ */
