/*
 * Copyright (C) 2022  Aleksei Bavshin
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, version 3.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

#include <cstdio>
#include <cstdlib>

#include "config.h"
#include "qtextgreeter.hpp"
#include "util/configuration.hpp"
#include <QtCore>

int main(int argc, char *argv[]) {
    QCoreApplication app(argc, argv);
    QCoreApplication::setApplicationName("qtextgreet");
    QCoreApplication::setApplicationVersion(QMLGREET_VERSION);

    auto &parser = QmlGreet::Configuration::createCommandLineParser();
    parser.addHelpOption();
    parser.addVersionOption();
    parser.process(app);

    QmlGreet::QTextGreeter *greeter = new QmlGreet::QTextGreeter(&app);
    QObject::connect(greeter, SIGNAL(done()), &app, SLOT(quit()));
    QTimer::singleShot(0, greeter, SLOT(start()));

    return app.exec();
}
