/*
 * Copyright (C) 2022  Aleksei Bavshin
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, version 3.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef QMLGREET_QTEXTGREETER_HPP_
#define QMLGREET_QTEXTGREETER_HPP_

#include "qgreetercontext.hpp"
#include <QtCore>

namespace QmlGreet {
class SessionModel;

class QTextGreeter : public QObject {
    Q_OBJECT;

  public:
    using PromptType = QGreetd::QGreetdClient::PromptType;
    using MessageType = QGreetd::QGreetdClient::MessageType;

    QTextGreeter(QObject *parent = nullptr);

  public slots:
    void start();
    void onConnect();

    void onShowPrompt(QString text, PromptType type);
    void onShowMessage(QString text, MessageType type);
    void onReset();

  signals:
    void done();

  private:
    QGreeterContext client;
};

} // namespace QmlGreet

#endif /* QMLGREET_QTEXTGREETER_HPP_ */
