/*
 * Copyright (C) 2022  Aleksei Bavshin
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, version 3.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef QMLGREET_UTIL_CONFIGURATION_P_HPP_
#define QMLGREET_UTIL_CONFIGURATION_P_HPP_

#include "configuration.hpp"
#include <memory>

namespace QmlGreet {

class ConfigurationPrivate {
  public:
    ConfigurationPrivate(std::function<QSettings()> settingsFactory = &defaultSettings);

    /* QSettings was rejecting all my attempts to move it :)*/
    static QSettings defaultSettings();
    static std::list<Option> &getOptionList();
    static std::unique_ptr<ConfigurationPrivate> &instance();

    QCommandLineParser m_cli;
    QSettings m_settings;
};

} // namespace QmlGreet

#endif /* QMLGREET_UTIL_CONFIGURATION_P_HPP_ */
